/* Dock.c generated by valac 0.47.3, the Vala compiler
 * generated from Dock.vala, do not modify */

/*
* Copyright (c) 2016 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <plank.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <libgnome-desktop/gnome-rr.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

#define TYPE_DOCK (dock_get_type ())
#define DOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCK, Dock))
#define DOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCK, DockClass))
#define IS_DOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCK))
#define IS_DOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCK))
#define DOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCK, DockClass))

typedef struct _Dock Dock;
typedef struct _DockClass DockClass;
typedef struct _DockPrivate DockPrivate;
enum  {
	DOCK_0_PROPERTY,
	DOCK_NUM_PROPERTIES
};
static GParamSpec* dock_properties[DOCK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block7Data Block7Data;

struct _Dock {
	GtkGrid parent_instance;
	DockPrivate * priv;
};

struct _DockClass {
	GtkGridClass parent_class;
};

struct _DockPrivate {
	GtkLabel* primary_monitor_label;
	GtkSwitch* primary_monitor;
	GtkLabel* monitor_label;
	GtkComboBoxText* monitor;
	PlankDockPreferences* dock_preferences;
};

struct _Block7Data {
	int _ref_count_;
	Dock* self;
	GraniteWidgetsModeButton* icon_size;
	gint current;
	GtkComboBoxText* hide_mode;
	PlankHideType* hide_mode_ids;
	gint hide_mode_ids_length1;
	gint _hide_mode_ids_size_;
	GtkSwitch* hide_switch;
};

static gint Dock_private_offset;
static gpointer dock_parent_class = NULL;

GType dock_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Dock, g_object_unref)
static void dock_check_for_screens (Dock* self);
static gint dock_find_monitor_number (GdkDisplay* display,
                               const gchar* plug_name);
static gchar** dock_get_monitor_plug_names (GdkDisplay* display,
                                     gint* result_length1);
Dock* dock_new (void);
Dock* dock_construct (GType object_type);
static GObject * dock_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
#define CONSTANTS_PLANKDATADIR "/usr/share/plank"
static void _dock___lambda18_ (Block7Data* _data7_);
static void __dock___lambda18__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                  GtkWidget* widget,
                                                                  gpointer self);
static void _dock___lambda19_ (Block7Data* _data7_);
static void __dock___lambda19__gtk_combo_box_changed (GtkComboBox* _sender,
                                               gpointer self);
static void _dock___lambda20_ (Block7Data* _data7_);
static void __dock___lambda20__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void _dock___lambda21_ (Dock* self);
static void __dock___lambda21__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void _dock___lambda22_ (Dock* self);
static void __dock___lambda22__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void _dock___lambda23_ (Dock* self);
static void __dock___lambda23__gdk_screen_monitors_changed (GdkScreen* _sender,
                                                     gpointer self);
static void dock_finalize (GObject * obj);
static GType dock_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
dock_get_instance_private (Dock* self)
{
	return G_STRUCT_MEMBER_P (self, Dock_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
dock_check_for_screens (Dock* self)
{
	gint i = 0;
	gint primary_screen = 0;
	GdkDisplay* default_display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkScreen* default_screen = NULL;
	GdkScreen* _tmp2_;
	GdkScreen* _tmp3_;
	GtkComboBoxText* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	i = 0;
	primary_screen = 0;
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	default_display = _tmp1_;
	_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	default_screen = _tmp3_;
	_tmp4_ = self->priv->monitor;
	gtk_combo_box_text_remove_all (_tmp4_);
	{
		GnomeRRScreen* screen = NULL;
		GdkScreen* _tmp5_;
		GnomeRRScreen* _tmp6_;
		_tmp5_ = default_screen;
		_tmp6_ = gnome_rr_screen_new (_tmp5_, &_inner_error0_);
		screen = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch16_g_error;
		}
		{
			gboolean _tmp7_ = FALSE;
			i = 0;
			_tmp7_ = TRUE;
			while (TRUE) {
				GdkDisplay* _tmp9_;
				gchar* monitor_plug_name = NULL;
				GdkDisplay* _tmp10_;
				GdkMonitor* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				GtkComboBoxText* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = i;
					i = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				_tmp9_ = default_display;
				if (!(i < gdk_display_get_n_monitors (_tmp9_))) {
					break;
				}
				_tmp10_ = default_display;
				_tmp11_ = gdk_display_get_monitor (_tmp10_, i);
				_tmp12_ = gdk_monitor_get_model (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_strdup (_tmp13_);
				monitor_plug_name = _tmp14_;
				_tmp15_ = monitor_plug_name;
				if (_tmp15_ != NULL) {
					GnomeRROutput* output = NULL;
					GnomeRRScreen* _tmp16_;
					const gchar* _tmp17_;
					GnomeRROutput* _tmp18_;
					gboolean _tmp19_ = FALSE;
					gboolean _tmp20_ = FALSE;
					GnomeRROutput* _tmp21_;
					_tmp16_ = screen;
					_tmp17_ = monitor_plug_name;
					_tmp18_ = gnome_rr_screen_get_output_by_name (_tmp16_, _tmp17_);
					output = _tmp18_;
					_tmp21_ = output;
					if (_tmp21_ != NULL) {
						GnomeRROutput* _tmp22_;
						const gchar* _tmp23_;
						_tmp22_ = output;
						_tmp23_ = gnome_rr_output_get_display_name (_tmp22_);
						_tmp20_ = _tmp23_ != NULL;
					} else {
						_tmp20_ = FALSE;
					}
					if (_tmp20_) {
						GnomeRROutput* _tmp24_;
						const gchar* _tmp25_;
						_tmp24_ = output;
						_tmp25_ = gnome_rr_output_get_display_name (_tmp24_);
						_tmp19_ = g_strcmp0 (_tmp25_, "") != 0;
					} else {
						_tmp19_ = FALSE;
					}
					if (_tmp19_) {
						GtkComboBoxText* _tmp26_;
						GnomeRROutput* _tmp27_;
						const gchar* _tmp28_;
						GnomeRROutput* _tmp29_;
						_tmp26_ = self->priv->monitor;
						_tmp27_ = output;
						_tmp28_ = gnome_rr_output_get_display_name (_tmp27_);
						gtk_combo_box_text_append_text (_tmp26_, _tmp28_);
						_tmp29_ = output;
						if (gnome_rr_output_get_is_primary (_tmp29_) == TRUE) {
							primary_screen = i;
						}
						_g_free0 (monitor_plug_name);
						continue;
					}
				}
				_tmp30_ = self->priv->monitor;
				_tmp31_ = g_strdup_printf (_ ("Monitor %d"), i + 1);
				_tmp32_ = _tmp31_;
				gtk_combo_box_text_append_text (_tmp30_, _tmp32_);
				_g_free0 (_tmp32_);
				_g_free0 (monitor_plug_name);
			}
		}
		_g_object_unref0 (screen);
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* e = NULL;
		GError* _tmp33_;
		const gchar* _tmp34_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp33_ = e;
		_tmp34_ = _tmp33_->message;
		g_critical ("Dock.vala:206: %s", _tmp34_);
		{
			gboolean _tmp35_ = FALSE;
			i = 0;
			_tmp35_ = TRUE;
			while (TRUE) {
				GdkDisplay* _tmp37_;
				GtkComboBoxText* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				if (!_tmp35_) {
					gint _tmp36_;
					_tmp36_ = i;
					i = _tmp36_ + 1;
				}
				_tmp35_ = FALSE;
				_tmp37_ = default_display;
				if (!(i < gdk_display_get_n_monitors (_tmp37_))) {
					break;
				}
				_tmp38_ = self->priv->monitor;
				_tmp39_ = g_strdup_printf (_ ("Display %d"), i + 1);
				_tmp40_ = _tmp39_;
				gtk_combo_box_text_append_text (_tmp38_, _tmp40_);
				_g_free0 (_tmp40_);
			}
		}
		_g_error_free0 (e);
	}
	__finally16:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (default_screen);
		_g_object_unref0 (default_display);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	if (i <= 1) {
		GtkLabel* _tmp41_;
		GtkSwitch* _tmp42_;
		GtkLabel* _tmp43_;
		GtkComboBoxText* _tmp44_;
		GtkComboBoxText* _tmp45_;
		_tmp41_ = self->priv->primary_monitor_label;
		gtk_widget_hide ((GtkWidget*) _tmp41_);
		_tmp42_ = self->priv->primary_monitor;
		gtk_widget_hide ((GtkWidget*) _tmp42_);
		_tmp43_ = self->priv->monitor_label;
		gtk_widget_hide ((GtkWidget*) _tmp43_);
		_tmp44_ = self->priv->monitor;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp44_, TRUE);
		_tmp45_ = self->priv->monitor;
		gtk_widget_hide ((GtkWidget*) _tmp45_);
	} else {
		PlankDockPreferences* _tmp46_;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		GtkLabel* _tmp55_;
		GtkSwitch* _tmp56_;
		GtkLabel* _tmp57_;
		GtkComboBoxText* _tmp58_;
		_tmp46_ = self->priv->dock_preferences;
		_tmp47_ = plank_dock_preferences_get_Monitor (_tmp46_);
		_tmp48_ = _tmp47_;
		if (g_strcmp0 (_tmp48_, "") != 0) {
			GtkComboBoxText* _tmp49_;
			GdkDisplay* _tmp50_;
			PlankDockPreferences* _tmp51_;
			const gchar* _tmp52_;
			const gchar* _tmp53_;
			_tmp49_ = self->priv->monitor;
			_tmp50_ = gtk_widget_get_display ((GtkWidget*) self);
			_tmp51_ = self->priv->dock_preferences;
			_tmp52_ = plank_dock_preferences_get_Monitor (_tmp51_);
			_tmp53_ = _tmp52_;
			gtk_combo_box_set_active ((GtkComboBox*) _tmp49_, dock_find_monitor_number (_tmp50_, _tmp53_));
		} else {
			GtkComboBoxText* _tmp54_;
			_tmp54_ = self->priv->monitor;
			gtk_combo_box_set_active ((GtkComboBox*) _tmp54_, primary_screen);
		}
		_tmp55_ = self->priv->primary_monitor_label;
		gtk_widget_show ((GtkWidget*) _tmp55_);
		_tmp56_ = self->priv->primary_monitor;
		gtk_widget_show ((GtkWidget*) _tmp56_);
		_tmp57_ = self->priv->monitor_label;
		gtk_widget_show ((GtkWidget*) _tmp57_);
		_tmp58_ = self->priv->monitor;
		gtk_widget_show ((GtkWidget*) _tmp58_);
	}
	_g_object_unref0 (default_screen);
	_g_object_unref0 (default_display);
}

static gchar**
dock_get_monitor_plug_names (GdkDisplay* display,
                             gint* result_length1)
{
	gint n_monitors = 0;
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** result = NULL;
	g_return_val_if_fail (display != NULL, NULL);
	n_monitors = gdk_display_get_n_monitors (display);
	_tmp0_ = g_new0 (gchar*, n_monitors + 1);
	_result_ = _tmp0_;
	_result__length1 = n_monitors;
	__result__size_ = _result__length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gchar** _tmp3_;
				gint _tmp3__length1;
				GdkMonitor* _tmp4_;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < n_monitors)) {
					break;
				}
				_tmp3_ = _result_;
				_tmp3__length1 = _result__length1;
				_tmp4_ = gdk_display_get_monitor (display, i);
				_tmp5_ = gdk_monitor_get_model (_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp7_ = g_strdup (_tmp6_);
				_g_free0 (_tmp3_[i]);
				_tmp3_[i] = _tmp7_;
			}
		}
	}
	_tmp8_ = _result_;
	_tmp8__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	return result;
}

static gint
dock_find_monitor_number (GdkDisplay* display,
                          const gchar* plug_name)
{
	gint n_monitors = 0;
	gint result = 0;
	g_return_val_if_fail (display != NULL, 0);
	g_return_val_if_fail (plug_name != NULL, 0);
	n_monitors = gdk_display_get_n_monitors (display);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GdkMonitor* monitor = NULL;
				GdkMonitor* _tmp2_;
				GdkMonitor* _tmp3_;
				gchar* name = NULL;
				GdkMonitor* _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				const gchar* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < n_monitors)) {
					break;
				}
				_tmp2_ = gdk_display_get_monitor (display, i);
				_tmp3_ = _g_object_ref0 (_tmp2_);
				monitor = _tmp3_;
				_tmp4_ = monitor;
				_tmp5_ = gdk_monitor_get_model (_tmp4_);
				_tmp6_ = g_strdup (_tmp5_);
				name = _tmp6_;
				_tmp7_ = name;
				if (g_strcmp0 (plug_name, _tmp7_) == 0) {
					result = i;
					_g_free0 (name);
					_g_object_unref0 (monitor);
					return result;
				}
				_g_free0 (name);
				_g_object_unref0 (monitor);
			}
		}
	}
	result = gdk_display_get_n_monitors (display);
	return result;
}

Dock*
dock_construct (GType object_type)
{
	Dock * self = NULL;
	self = (Dock*) g_object_new (object_type, NULL);
	return self;
}

Dock*
dock_new (void)
{
	return dock_construct (TYPE_DOCK);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		Dock* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->hide_switch);
		_data7_->hide_mode_ids = (g_free (_data7_->hide_mode_ids), NULL);
		_g_object_unref0 (_data7_->hide_mode);
		_g_object_unref0 (_data7_->icon_size);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
_dock___lambda18_ (Block7Data* _data7_)
{
	Dock* self;
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	self = _data7_->self;
	_tmp0_ = _data7_->icon_size;
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case 0:
		{
			PlankDockPreferences* _tmp3_;
			_tmp3_ = self->priv->dock_preferences;
			plank_dock_preferences_set_IconSize (_tmp3_, 32);
			break;
		}
		case 1:
		{
			PlankDockPreferences* _tmp4_;
			_tmp4_ = self->priv->dock_preferences;
			plank_dock_preferences_set_IconSize (_tmp4_, 48);
			break;
		}
		case 2:
		{
			PlankDockPreferences* _tmp5_;
			_tmp5_ = self->priv->dock_preferences;
			plank_dock_preferences_set_IconSize (_tmp5_, 64);
			break;
		}
		case 3:
		{
			PlankDockPreferences* _tmp6_;
			_tmp6_ = self->priv->dock_preferences;
			plank_dock_preferences_set_IconSize (_tmp6_, _data7_->current);
			break;
		}
		default:
		break;
	}
}

static void
__dock___lambda18__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                             GtkWidget* widget,
                                                             gpointer self)
{
	_dock___lambda18_ (self);
}

static void
_dock___lambda19_ (Block7Data* _data7_)
{
	Dock* self;
	PlankDockPreferences* _tmp0_;
	PlankHideType* _tmp1_;
	gint _tmp1__length1;
	GtkComboBoxText* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	PlankHideType _tmp5_;
	self = _data7_->self;
	_tmp0_ = self->priv->dock_preferences;
	_tmp1_ = _data7_->hide_mode_ids;
	_tmp1__length1 = _data7_->hide_mode_ids_length1;
	_tmp2_ = _data7_->hide_mode;
	_tmp3_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp1_[_tmp4_];
	plank_dock_preferences_set_HideMode (_tmp0_, _tmp5_);
}

static void
__dock___lambda19__gtk_combo_box_changed (GtkComboBox* _sender,
                                          gpointer self)
{
	_dock___lambda19_ (self);
}

static void
_dock___lambda20_ (Block7Data* _data7_)
{
	Dock* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data7_->self;
	_tmp0_ = _data7_->hide_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		PlankDockPreferences* _tmp3_;
		PlankHideType* _tmp4_;
		gint _tmp4__length1;
		GtkComboBoxText* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		PlankHideType _tmp8_;
		_tmp3_ = self->priv->dock_preferences;
		_tmp4_ = _data7_->hide_mode_ids;
		_tmp4__length1 = _data7_->hide_mode_ids_length1;
		_tmp5_ = _data7_->hide_mode;
		_tmp6_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp4_[_tmp7_];
		plank_dock_preferences_set_HideMode (_tmp3_, _tmp8_);
	} else {
		PlankDockPreferences* _tmp9_;
		_tmp9_ = self->priv->dock_preferences;
		plank_dock_preferences_set_HideMode (_tmp9_, PLANK_HIDE_TYPE_NONE);
	}
}

static void
__dock___lambda20__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
	_dock___lambda20_ (self);
}

static void
_dock___lambda21_ (Dock* self)
{
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->primary_monitor;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == TRUE) {
		PlankDockPreferences* _tmp3_;
		GtkLabel* _tmp4_;
		GtkComboBoxText* _tmp5_;
		_tmp3_ = self->priv->dock_preferences;
		plank_dock_preferences_set_Monitor (_tmp3_, "");
		_tmp4_ = self->priv->monitor_label;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, FALSE);
		_tmp5_ = self->priv->monitor;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
	} else {
		gchar** plug_names = NULL;
		GdkDisplay* _tmp6_;
		gint _tmp7_ = 0;
		gchar** _tmp8_;
		gint plug_names_length1;
		gint _plug_names_size_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		GtkComboBoxText* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		GtkLabel* _tmp19_;
		GtkComboBoxText* _tmp20_;
		_tmp6_ = gtk_widget_get_display ((GtkWidget*) self);
		_tmp8_ = dock_get_monitor_plug_names (_tmp6_, &_tmp7_);
		plug_names = _tmp8_;
		plug_names_length1 = _tmp7_;
		_plug_names_size_ = plug_names_length1;
		_tmp9_ = plug_names;
		_tmp9__length1 = plug_names_length1;
		_tmp10_ = self->priv->monitor;
		_tmp11_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp10_);
		_tmp12_ = _tmp11_;
		if (_tmp9__length1 > _tmp12_) {
			PlankDockPreferences* _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
			GtkComboBoxText* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			const gchar* _tmp18_;
			_tmp13_ = self->priv->dock_preferences;
			_tmp14_ = plug_names;
			_tmp14__length1 = plug_names_length1;
			_tmp15_ = self->priv->monitor;
			_tmp16_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = _tmp14_[_tmp17_];
			plank_dock_preferences_set_Monitor (_tmp13_, _tmp18_);
		}
		_tmp19_ = self->priv->monitor_label;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, TRUE);
		_tmp20_ = self->priv->monitor;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, TRUE);
		plug_names = (_vala_array_free (plug_names, plug_names_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
__dock___lambda21__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
	_dock___lambda21_ ((Dock*) self);
}

static void
_dock___lambda22_ (Dock* self)
{
	gboolean _tmp0_ = FALSE;
	GtkComboBoxText* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	_tmp1_ = self->priv->monitor;
	_tmp2_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ >= 0) {
		GtkSwitch* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->primary_monitor;
		_tmp5_ = gtk_switch_get_active (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ == FALSE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar** plug_names = NULL;
		GdkDisplay* _tmp7_;
		gint _tmp8_ = 0;
		gchar** _tmp9_;
		gint plug_names_length1;
		gint _plug_names_size_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		GtkComboBoxText* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		_tmp7_ = gtk_widget_get_display ((GtkWidget*) self);
		_tmp9_ = dock_get_monitor_plug_names (_tmp7_, &_tmp8_);
		plug_names = _tmp9_;
		plug_names_length1 = _tmp8_;
		_plug_names_size_ = plug_names_length1;
		_tmp10_ = plug_names;
		_tmp10__length1 = plug_names_length1;
		_tmp11_ = self->priv->monitor;
		_tmp12_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp10__length1 > _tmp13_) {
			PlankDockPreferences* _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			GtkComboBoxText* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			const gchar* _tmp19_;
			_tmp14_ = self->priv->dock_preferences;
			_tmp15_ = plug_names;
			_tmp15__length1 = plug_names_length1;
			_tmp16_ = self->priv->monitor;
			_tmp17_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = _tmp15_[_tmp18_];
			plank_dock_preferences_set_Monitor (_tmp14_, _tmp19_);
		}
		plug_names = (_vala_array_free (plug_names, plug_names_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
__dock___lambda22__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
	_dock___lambda22_ ((Dock*) self);
}

static void
_dock___lambda23_ (Dock* self)
{
	dock_check_for_screens (self);
}

static void
__dock___lambda23__gdk_screen_monitors_changed (GdkScreen* _sender,
                                                gpointer self)
{
	_dock___lambda23_ ((Dock*) self);
}

static GObject *
dock_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Dock * self;
	Block7Data* _data7_;
	GraniteWidgetsModeButton* _tmp0_;
	GraniteWidgetsModeButton* _tmp1_;
	GraniteWidgetsModeButton* _tmp2_;
	GraniteWidgetsModeButton* _tmp3_;
	PlankDockPreferences* _tmp4_;
	PlankDockPreferences* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GraniteWidgetsModeButton* _tmp15_;
	GtkSwitch* pressure_switch = NULL;
	GtkSwitch* _tmp16_;
	GtkSwitch* _tmp17_;
	GtkSwitch* _tmp18_;
	PlankDockPreferences* _tmp19_;
	GtkSwitch* _tmp20_;
	GtkComboBoxText* _tmp21_;
	GtkComboBoxText* _tmp22_;
	GtkComboBoxText* _tmp23_;
	GtkComboBoxText* _tmp24_;
	GtkComboBoxText* _tmp25_;
	PlankHideType* _tmp26_;
	GtkSwitch* _tmp27_;
	GtkSwitch* _tmp28_;
	GtkSwitch* _tmp29_;
	gboolean hide_none = FALSE;
	PlankDockPreferences* _tmp30_;
	PlankHideType _tmp31_;
	PlankHideType _tmp32_;
	GtkSwitch* _tmp33_;
	GtkComboBoxText* _tmp44_;
	GtkSwitch* _tmp45_;
	GtkSwitch* _tmp46_;
	GtkSwitch* _tmp47_;
	GtkComboBoxText* _tmp48_;
	GtkSwitch* _tmp49_;
	GtkComboBoxText* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	GtkLabel* _tmp56_;
	GtkSwitch* _tmp57_;
	GtkSwitch* _tmp58_;
	GtkSwitch* _tmp59_;
	GtkSwitch* _tmp60_;
	PlankDockPreferences* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	GtkComboBoxText* _tmp64_;
	GdkScreen* _tmp65_;
	GtkLabel* icon_label = NULL;
	GtkLabel* _tmp66_;
	GtkLabel* _tmp67_;
	GtkLabel* hide_label = NULL;
	GtkLabel* _tmp68_;
	GtkLabel* _tmp69_;
	GtkGrid* primary_monitor_grid = NULL;
	GtkGrid* _tmp70_;
	GtkGrid* _tmp71_;
	GtkSwitch* _tmp72_;
	GtkLabel* pressure_label = NULL;
	GtkLabel* _tmp73_;
	GtkLabel* _tmp74_;
	GtkLabel* _tmp75_;
	GraniteWidgetsModeButton* _tmp76_;
	GtkLabel* _tmp77_;
	GtkComboBoxText* _tmp78_;
	GtkSwitch* _tmp79_;
	GtkLabel* _tmp80_;
	GtkGrid* _tmp81_;
	GtkLabel* _tmp82_;
	GtkComboBoxText* _tmp83_;
	GtkLabel* _tmp84_;
	GtkSwitch* _tmp85_;
	parent_class = G_OBJECT_CLASS (dock_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOCK, Dock);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	gtk_widget_set_margin_end ((GtkWidget*) self, 6);
	gtk_widget_set_margin_start ((GtkWidget*) self, 6);
	_tmp0_ = granite_widgets_mode_button_new ();
	g_object_ref_sink (_tmp0_);
	_data7_->icon_size = _tmp0_;
	_tmp1_ = _data7_->icon_size;
	granite_widgets_mode_button_append_text (_tmp1_, _ ("Small"));
	_tmp2_ = _data7_->icon_size;
	granite_widgets_mode_button_append_text (_tmp2_, _ ("Normal"));
	_tmp3_ = _data7_->icon_size;
	granite_widgets_mode_button_append_text (_tmp3_, _ ("Large"));
	plank_paths_initialize ("plank", CONSTANTS_PLANKDATADIR);
	_tmp4_ = plank_dock_preferences_new ("dock1");
	_g_object_unref0 (self->priv->dock_preferences);
	self->priv->dock_preferences = _tmp4_;
	_tmp5_ = self->priv->dock_preferences;
	_tmp6_ = plank_dock_preferences_get_IconSize (_tmp5_);
	_tmp7_ = _tmp6_;
	_data7_->current = _tmp7_;
	switch (_data7_->current) {
		case 32:
		{
			GraniteWidgetsModeButton* _tmp8_;
			_tmp8_ = _data7_->icon_size;
			granite_widgets_mode_button_set_selected (_tmp8_, 0);
			break;
		}
		case 48:
		{
			GraniteWidgetsModeButton* _tmp9_;
			_tmp9_ = _data7_->icon_size;
			granite_widgets_mode_button_set_selected (_tmp9_, 1);
			break;
		}
		case 64:
		{
			GraniteWidgetsModeButton* _tmp10_;
			_tmp10_ = _data7_->icon_size;
			granite_widgets_mode_button_set_selected (_tmp10_, 2);
			break;
		}
		default:
		{
			GraniteWidgetsModeButton* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GraniteWidgetsModeButton* _tmp14_;
			_tmp11_ = _data7_->icon_size;
			_tmp12_ = g_strdup_printf (_ ("Custom (%dpx)"), _data7_->current);
			_tmp13_ = _tmp12_;
			granite_widgets_mode_button_append_text (_tmp11_, _tmp13_);
			_g_free0 (_tmp13_);
			_tmp14_ = _data7_->icon_size;
			granite_widgets_mode_button_set_selected (_tmp14_, 3);
			break;
		}
	}
	_tmp15_ = _data7_->icon_size;
	g_signal_connect_data (_tmp15_, "mode-changed", (GCallback) __dock___lambda18__granite_widgets_mode_button_mode_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp16_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp16_);
	pressure_switch = _tmp16_;
	_tmp17_ = pressure_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_START);
	_tmp18_ = pressure_switch;
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
	_tmp19_ = self->priv->dock_preferences;
	_tmp20_ = pressure_switch;
	g_object_bind_property_with_closures ((GObject*) _tmp19_, "PressureReveal", (GObject*) _tmp20_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp21_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp21_);
	_data7_->hide_mode = _tmp21_;
	_tmp22_ = _data7_->hide_mode;
	gtk_combo_box_text_append_text (_tmp22_, _ ("Focused window is maximized"));
	_tmp23_ = _data7_->hide_mode;
	gtk_combo_box_text_append_text (_tmp23_, _ ("Focused window overlaps the dock"));
	_tmp24_ = _data7_->hide_mode;
	gtk_combo_box_text_append_text (_tmp24_, _ ("Any window overlaps the dock"));
	_tmp25_ = _data7_->hide_mode;
	gtk_combo_box_text_append_text (_tmp25_, _ ("Not being used"));
	_tmp26_ = g_new0 (PlankHideType, 4);
	_tmp26_[0] = PLANK_HIDE_TYPE_DODGE_MAXIMIZED;
	_tmp26_[1] = PLANK_HIDE_TYPE_INTELLIGENT;
	_tmp26_[2] = PLANK_HIDE_TYPE_WINDOW_DODGE;
	_tmp26_[3] = PLANK_HIDE_TYPE_AUTO;
	_data7_->hide_mode_ids = _tmp26_;
	_data7_->hide_mode_ids_length1 = 4;
	_data7_->_hide_mode_ids_size_ = _data7_->hide_mode_ids_length1;
	_tmp27_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp27_);
	_data7_->hide_switch = _tmp27_;
	_tmp28_ = _data7_->hide_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
	_tmp29_ = _data7_->hide_switch;
	gtk_widget_set_valign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
	_tmp30_ = self->priv->dock_preferences;
	_tmp31_ = plank_dock_preferences_get_HideMode (_tmp30_);
	_tmp32_ = _tmp31_;
	hide_none = _tmp32_ != PLANK_HIDE_TYPE_NONE;
	_tmp33_ = _data7_->hide_switch;
	gtk_switch_set_active (_tmp33_, hide_none);
	if (hide_none) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp34_ = FALSE;
				_tmp34_ = TRUE;
				while (TRUE) {
					PlankHideType* _tmp36_;
					gint _tmp36__length1;
					PlankHideType* _tmp37_;
					gint _tmp37__length1;
					PlankHideType _tmp38_;
					PlankDockPreferences* _tmp39_;
					PlankHideType _tmp40_;
					PlankHideType _tmp41_;
					if (!_tmp34_) {
						gint _tmp35_;
						_tmp35_ = i;
						i = _tmp35_ + 1;
					}
					_tmp34_ = FALSE;
					_tmp36_ = _data7_->hide_mode_ids;
					_tmp36__length1 = _data7_->hide_mode_ids_length1;
					if (!(i < _tmp36__length1)) {
						break;
					}
					_tmp37_ = _data7_->hide_mode_ids;
					_tmp37__length1 = _data7_->hide_mode_ids_length1;
					_tmp38_ = _tmp37_[i];
					_tmp39_ = self->priv->dock_preferences;
					_tmp40_ = plank_dock_preferences_get_HideMode (_tmp39_);
					_tmp41_ = _tmp40_;
					if (_tmp38_ == _tmp41_) {
						GtkComboBoxText* _tmp42_;
						_tmp42_ = _data7_->hide_mode;
						gtk_combo_box_set_active ((GtkComboBox*) _tmp42_, i);
					}
				}
			}
		}
	} else {
		GtkComboBoxText* _tmp43_;
		_tmp43_ = _data7_->hide_mode;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp43_, FALSE);
	}
	_tmp44_ = _data7_->hide_mode;
	g_signal_connect_data ((GtkComboBox*) _tmp44_, "changed", (GCallback) __dock___lambda19__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp45_ = _data7_->hide_switch;
	_tmp46_ = pressure_switch;
	g_object_bind_property_with_closures ((GObject*) _tmp45_, "active", (GObject*) _tmp46_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp47_ = _data7_->hide_switch;
	_tmp48_ = _data7_->hide_mode;
	g_object_bind_property_with_closures ((GObject*) _tmp47_, "active", (GObject*) _tmp48_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp49_ = _data7_->hide_switch;
	g_signal_connect_data ((GObject*) _tmp49_, "notify::active", (GCallback) __dock___lambda20__g_object_notify, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp50_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp50_);
	_g_object_unref0 (self->priv->monitor);
	self->priv->monitor = _tmp50_;
	_tmp51_ = (GtkLabel*) gtk_label_new (_ ("Primary display:"));
	g_object_ref_sink (_tmp51_);
	_g_object_unref0 (self->priv->primary_monitor_label);
	self->priv->primary_monitor_label = _tmp51_;
	_tmp52_ = self->priv->primary_monitor_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp52_, GTK_ALIGN_END);
	_tmp53_ = self->priv->primary_monitor_label;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp53_, TRUE);
	_tmp54_ = (GtkLabel*) gtk_label_new (_ ("Display:"));
	g_object_ref_sink (_tmp54_);
	_g_object_unref0 (self->priv->monitor_label);
	self->priv->monitor_label = _tmp54_;
	_tmp55_ = self->priv->monitor_label;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp55_, TRUE);
	_tmp56_ = self->priv->monitor_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp56_, GTK_ALIGN_END);
	_tmp57_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp57_);
	_g_object_unref0 (self->priv->primary_monitor);
	self->priv->primary_monitor = _tmp57_;
	_tmp58_ = self->priv->primary_monitor;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp58_, TRUE);
	_tmp59_ = self->priv->primary_monitor;
	g_signal_connect_object ((GObject*) _tmp59_, "notify::active", (GCallback) __dock___lambda21__g_object_notify, self, 0);
	_tmp60_ = self->priv->primary_monitor;
	_tmp61_ = self->priv->dock_preferences;
	_tmp62_ = plank_dock_preferences_get_Monitor (_tmp61_);
	_tmp63_ = _tmp62_;
	gtk_switch_set_active (_tmp60_, g_strcmp0 (_tmp63_, "") == 0);
	_tmp64_ = self->priv->monitor;
	g_signal_connect_object ((GObject*) _tmp64_, "notify::active", (GCallback) __dock___lambda22__g_object_notify, self, 0);
	_tmp65_ = gtk_widget_get_screen ((GtkWidget*) self);
	g_signal_connect_object (_tmp65_, "monitors-changed", (GCallback) __dock___lambda23__gdk_screen_monitors_changed, self, 0);
	_tmp66_ = (GtkLabel*) gtk_label_new (_ ("Icon size:"));
	g_object_ref_sink (_tmp66_);
	icon_label = _tmp66_;
	_tmp67_ = icon_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp67_, GTK_ALIGN_END);
	_tmp68_ = (GtkLabel*) gtk_label_new (_ ("Hide when:"));
	g_object_ref_sink (_tmp68_);
	hide_label = _tmp68_;
	_tmp69_ = hide_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp69_, GTK_ALIGN_END);
	_tmp70_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp70_);
	primary_monitor_grid = _tmp70_;
	_tmp71_ = primary_monitor_grid;
	_tmp72_ = self->priv->primary_monitor;
	gtk_container_add ((GtkContainer*) _tmp71_, (GtkWidget*) _tmp72_);
	_tmp73_ = (GtkLabel*) gtk_label_new (_ ("Pressure reveal:"));
	g_object_ref_sink (_tmp73_);
	pressure_label = _tmp73_;
	_tmp74_ = pressure_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp74_, GTK_ALIGN_END);
	_tmp75_ = icon_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp75_, 1, 0, 1, 1);
	_tmp76_ = _data7_->icon_size;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp76_, 2, 0, 1, 1);
	_tmp77_ = hide_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp77_, 1, 1, 1, 1);
	_tmp78_ = _data7_->hide_mode;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp78_, 2, 1, 1, 1);
	_tmp79_ = _data7_->hide_switch;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp79_, 3, 1, 1, 1);
	_tmp80_ = self->priv->primary_monitor_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp80_, 1, 3, 1, 1);
	_tmp81_ = primary_monitor_grid;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp81_, 2, 3, 1, 1);
	_tmp82_ = self->priv->monitor_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp82_, 1, 4, 1, 1);
	_tmp83_ = self->priv->monitor;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp83_, 2, 4, 1, 1);
	_tmp84_ = pressure_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp84_, 1, 5, 1, 1);
	_tmp85_ = pressure_switch;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp85_, 2, 5, 1, 1);
	dock_check_for_screens (self);
	_g_object_unref0 (pressure_label);
	_g_object_unref0 (primary_monitor_grid);
	_g_object_unref0 (hide_label);
	_g_object_unref0 (icon_label);
	_g_object_unref0 (pressure_switch);
	return obj;
}

static void
dock_class_init (DockClass * klass,
                 gpointer klass_data)
{
	dock_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Dock_private_offset);
	G_OBJECT_CLASS (klass)->constructor = dock_constructor;
	G_OBJECT_CLASS (klass)->finalize = dock_finalize;
}

static void
dock_instance_init (Dock * self,
                    gpointer klass)
{
	self->priv = dock_get_instance_private (self);
}

static void
dock_finalize (GObject * obj)
{
	Dock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOCK, Dock);
	_g_object_unref0 (self->priv->primary_monitor_label);
	_g_object_unref0 (self->priv->primary_monitor);
	_g_object_unref0 (self->priv->monitor_label);
	_g_object_unref0 (self->priv->monitor);
	_g_object_unref0 (self->priv->dock_preferences);
	G_OBJECT_CLASS (dock_parent_class)->finalize (obj);
}

static GType
dock_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Dock), 0, (GInstanceInitFunc) dock_instance_init, NULL };
	GType dock_type_id;
	dock_type_id = g_type_register_static (gtk_grid_get_type (), "Dock", &g_define_type_info, 0);
	Dock_private_offset = g_type_add_instance_private (dock_type_id, sizeof (DockPrivate));
	return dock_type_id;
}

GType
dock_get_type (void)
{
	static volatile gsize dock_type_id__volatile = 0;
	if (g_once_init_enter (&dock_type_id__volatile)) {
		GType dock_type_id;
		dock_type_id = dock_get_type_once ();
		g_once_init_leave (&dock_type_id__volatile, dock_type_id);
	}
	return dock_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

